package com.bitendo.game;
import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferStrategy;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Scanner;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
public class Game extends Canvas implements Runnable{
	private static final long serialVersionUID=1L;
	public static int WIDTH=800-10;
	public static int HEIGHT=480-4;
	public static BufferedImage sprites;
	public static BufferedImage title;
	public static InputHandler h;
	public static Image background;
	public static boolean running=false;
	public static boolean levelLoaded=false;
	BufferedImage back1,back2;
	public static int enemies;
	public static int wave=1;
	public static AudioClip gun;
	File gu;
	public static AudioClip explode;
	public static AudioClip music;
	File m;
	File ex;
	public static boolean boss;
	public static int bc=1;
	boolean prevx;
	public static int killed;
	boolean titlescreen=true;
	boolean prevz;
	public static BufferedImage BOSSES;
	public static int maxenemies=50;
	public static ArrayList<Entity>tiles=new ArrayList<Entity>();
	public static String[] maps={"test.txt","test2.txt","test3.txt","test4.txt","boss.txt"};
	public static int mapindex;
	public Game(){
		try {
			sprites=ImageIO.read(new File("res/sprites.png"));
			BOSSES=ImageIO.read(new File("res/bosses.png"));
			title=ImageIO.read(new File("res/title.png"));
			back1=ImageIO.read(new File("res/back1.png"));
			back2=ImageIO.read(new File("res/back2.png"));
			gu=new File("res/gun.wav");
			ex=new File("res/explosion.wav");
			m=new File("res/overworld.wav");
		} catch (IOException e) {
			e.printStackTrace();
		}
		try{
			gun= Applet.newAudioClip(gu.toURL());
			explode=Applet.newAudioClip(ex.toURL());
			music=Applet.newAudioClip(m.toURL());
		}catch(Exception e){
			e.printStackTrace();
		}music.loop();
		
		h=new InputHandler();
		addKeyListener(h);
	}
	public void start(){
		if(running){
			return;
		}
		running=true;
		new Thread(this).start();
		
	}
	public void run(){
		while(running){
			tick();
			render();
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	public void tick(){
		if(h.esc){
			System.exit(0);
		}
		if(!titlescreen){
			
			
			if(h.x&&prevx==false){
				wave++;
				for(int i=0;i<tiles.size();i++){
					if(tiles.get(i).type==3){
						tiles.get(i).removed=true;
					}
					if(tiles.get(i).type==0){
						tiles.get(i).health=100;
					}
				}
				mapindex++;
				maxenemies+=25;
				enemies=0;
				killed=0;
				levelLoaded=false;
			}
			if(mapindex>maps.length){
				mapindex=0;
				System.out.println("a");
			}
			
			if(!levelLoaded&&mapindex<maps.length){
				
				loadLevel("res/"+maps[mapindex]);
				levelLoaded=true;
			}
			for(int i=5;i<50;i+=5){
				if(wave==i){
					boss=true;
					mapindex=0;
					
				}
				else{
					boss=false;
				}
			}
			if(killed>=maxenemies&&!boss){
				wave++;
				for(int i=0;i<tiles.size();i++){
					if(tiles.get(i).type==3){
						tiles.get(i).removed=true;
					}
					if(tiles.get(i).type==0){
						tiles.get(i).health=100;
					}
				}
				mapindex++;
				maxenemies+=25;
				enemies=0;
				killed=0;
				levelLoaded=false;
			}
			if(mapindex==1){
				bc=2;
			}
			else{
				bc=1;
			}
			for(int i=0;i<tiles.size();i++){
				if(tiles.get(i).removed==false){
					tiles.get(i).update();}
				else{
					tiles.get(i).x=-256;
					tiles.get(i).y=-256;
					tiles.get(i).collisionMask.x=-1024;
					tiles.get(i).collisionMask.y=-1024;
				}
			}
			
		}
		if(titlescreen){
			if(h.z&&prevz==false){
				titlescreen=false;
				
				return;
			}
		}
		prevz=h.z;
		prevx=h.x;
	}
	public void render(){
		BufferStrategy bs=this.getBufferStrategy();
		if(bs==null){
			createBufferStrategy(2);
			return;
		}
		Graphics g=bs.getDrawGraphics();
		g.clearRect(0,0,WIDTH,HEIGHT);
		if(!titlescreen){
			if(bc==1){
				g.drawImage(back1,0,0,null);
			}
			else if(bc==2){
				g.drawImage(back2,0,0,null);
			}
			for(int i=0;i<tiles.size();i++){
				if(tiles.get(i).removed==false)
					g.drawImage(tiles.get(i).sprite,tiles.get(i).x,tiles.get(i).y,null);
				if(tiles.get(i).type==0){
					g.drawString("HP: "+String.valueOf(tiles.get(i).health),tiles.get(i).x-8,tiles.get(i).y-12);
				}
			}
			g.drawString("Wave: "+wave,32,400);
		}
		else{
			g.drawImage(title,0,0,null);
		}
		g.dispose();
		bs.show();
	}
	public static void loadLevel(String path){
		tiles.clear();
		Scanner sc;
		try {
			sc = new Scanner(new File(path));
			String[] rows=new String[30];
			for(int i=0;i<rows.length;i++){
				if(sc.hasNextLine()){
					rows[i]=sc.nextLine();
					char[] col=rows[i].toCharArray();
					for(int o=0;o<col.length;o++){
						if(col[o]=='P'){
							Player e=new Player(sprites.getSubimage(0,0,16,16));
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
						}
						if(col[o]=='*'){
							Wall e=new Wall(sprites.getSubimage(0,16,16,16));
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
						}
						if(col[o]=='1'){
							Boss e=new Boss(BOSSES.getSubimage(0,0,96,96),1);
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
						}
						if(col[o]=='+'){
							HealthPacl e=new HealthPacl(sprites.getSubimage(32,16,16,16));
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
						}
						if(col[o]=='^'){
							Enemy e=new Enemy(sprites.getSubimage(16,0,16,16));
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
							enemies++;
						}
						if(col[o]=='S'){
							Spawner e=new Spawner(sprites.getSubimage(0,16,16,16));
							e.x=o*16;
							e.y=i*16;
							tiles.add(e);
						}
					}
						
					System.out.println(rows[i]);
				
			}
		}
		}
		 catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		
		
	}
	public static void main(String[] args) {
		JFrame j=new JFrame();
		Game g=new Game();
		j.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		j.setSize(WIDTH,HEIGHT);
		j.setResizable(false);
		j.setLocationRelativeTo(null);
		j.add(g);
		j.setIconImage(sprites.getSubimage(0,0,32,32));
		j.setTitle("Why is everything square???");
		j.setVisible(true);
		g.start();
	}
}
